ccf23a23f2ba898893ba9c0a9ca8e63a5b9d765b
[ganeti-github.git] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 hypervisordir = $(pkgpythondir)/hypervisor
44 httpdir = $(pkgpythondir)/http
45 masterddir = $(pkgpythondir)/masterd
46 confddir = $(pkgpythondir)/confd
47 rapidir = $(pkgpythondir)/rapi
48 serverdir = $(pkgpythondir)/server
49 watcherdir = $(pkgpythondir)/watcher
50 impexpddir = $(pkgpythondir)/impexpd
51 utilsdir = $(pkgpythondir)/utils
52 toolsdir = $(pkglibdir)/tools
53 iallocatorsdir = $(pkglibdir)/iallocators
54 pytoolsdir = $(pkgpythondir)/tools
55 docdir = $(datadir)/doc/$(PACKAGE)
56 myexeclibdir = $(pkglibdir)
57
58 # Delete output file if an error occurred while building it
59 .DELETE_ON_ERROR:
60
61 HS_DIRS = \
62         src \
63         src/Ganeti \
64         src/Ganeti/Block \
65         src/Ganeti/Block/Drbd \
66         src/Ganeti/Confd \
67         src/Ganeti/DataCollectors \
68         src/Ganeti/HTools \
69         src/Ganeti/HTools/Backend \
70         src/Ganeti/HTools/Program \
71         src/Ganeti/Query \
72         test/hs \
73         test/hs/Test \
74         test/hs/Test/Ganeti \
75         test/hs/Test/Ganeti/Block \
76         test/hs/Test/Ganeti/Block/Drbd \
77         test/hs/Test/Ganeti/Confd \
78         test/hs/Test/Ganeti/HTools \
79         test/hs/Test/Ganeti/HTools/Backend \
80         test/hs/Test/Ganeti/Query
81
82 # Haskell directories without the roots (src, test/hs)
83 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
84
85 DIRS = \
86         $(HS_DIRS) \
87         autotools \
88         daemons \
89         devel \
90         doc \
91         doc/css \
92         doc/examples \
93         doc/examples/gnt-debug \
94         doc/examples/hooks \
95         test/data/htools \
96         test/data/htools/rapi \
97         test/hs/shelltests \
98         lib \
99         lib/build \
100         lib/client \
101         lib/confd \
102         lib/http \
103         lib/hypervisor \
104         lib/impexpd \
105         lib/masterd \
106         lib/rapi \
107         lib/server \
108         lib/tools \
109         lib/utils \
110         lib/watcher \
111         man \
112         qa \
113         test \
114         test/data \
115         test/data/bdev-rbd \
116         test/data/ovfdata \
117         test/data/ovfdata/other \
118         test/py \
119         tools
120
121 ALL_APIDOC_HS_DIRS = \
122         $(APIDOC_HS_DIR) \
123         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
124
125 BUILDTIME_DIR_AUTOCREATE = \
126         scripts \
127         $(APIDOC_DIR) \
128         $(ALL_APIDOC_HS_DIRS) \
129         $(APIDOC_PY_DIR) \
130         $(COVERAGE_DIR) \
131         $(COVERAGE_HS_DIR) \
132         $(COVERAGE_PY_DIR) \
133         .hpc
134
135 BUILDTIME_DIRS = \
136         $(BUILDTIME_DIR_AUTOCREATE) \
137         doc/html \
138         doc/man-html
139
140 DIRCHECK_EXCLUDE = \
141         $(BUILDTIME_DIRS) \
142         ganeti-[0-9]*.[0-9]*.[0-9]* \
143         doc/html/_* \
144         doc/man-html/_* \
145         autom4te.cache
146
147 # some helper vars
148 COVERAGE_DIR = doc/coverage
149 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
150 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
151 APIDOC_DIR = doc/api
152 APIDOC_PY_DIR = $(APIDOC_DIR)/py
153 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
154
155 MAINTAINERCLEANFILES = \
156         $(maninput) \
157         doc/install-quick.rst \
158         doc/news.rst \
159         doc/upgrade.rst \
160         vcs-version
161
162 maintainer-clean-local:
163         rm -rf $(BUILDTIME_DIRS)
164
165 CLEANFILES = \
166         $(addsuffix /*.py[co],$(DIRS)) \
167         $(addsuffix /*.hi,$(HS_DIRS)) \
168         $(addsuffix /*.o,$(HS_DIRS)) \
169         $(PYTHON_BOOTSTRAP) \
170         epydoc.conf \
171         $(REPLACE_VARS_SED) \
172         $(SHELL_ENV_INIT) \
173         daemons/daemon-util \
174         daemons/ganeti-cleaner \
175         $(mandocrst) \
176         doc/manpages-enabled.rst \
177         $(BUILT_EXAMPLES) \
178         doc/examples/bash_completion \
179         doc/examples/bash_completion-debug \
180         lib/_generated_rpc.py \
181         $(man_MANS) \
182         $(manhtml) \
183         tools/kvm-ifup \
184         tools/users-setup \
185         tools/vcluster-setup \
186         stamp-directories \
187         stamp-srclinks \
188         $(nodist_pkgpython_PYTHON) \
189         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
190         $(HS_BUILT_TEST_HELPERS) \
191         src/ganeti-confd \
192         .hpc/*.mix src/*.tix test/hs/*.tix \
193         doc/hs-lint.html
194
195 GENERATED_FILES = \
196         $(built_base_sources) \
197         $(BUILT_PYTHON_SOURCES) \
198         $(PYTHON_BOOTSTRAP)
199
200 HS_GENERATED_FILES =
201 if WANT_HTOOLS
202 HS_GENERATED_FILES += $(HS_PROGS)
203 if ENABLE_CONFD
204 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
205 endif
206 endif
207
208 built_base_sources = \
209         stamp-directories \
210         stamp-srclinks
211
212 built_python_base_sources = \
213         lib/_autoconf.py \
214         lib/_vcsversion.py
215
216 BUILT_PYTHON_SOURCES = \
217         $(built_python_base_sources) \
218         lib/_generated_rpc.py
219
220 # Generating the RPC wrappers depends on many things, so make sure
221 # it's built at the end of the built sources
222 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
223
224 # these are all built from the underlying %.in sources
225 BUILT_EXAMPLES = \
226         doc/examples/ganeti-kvm-poweroff.initd \
227         doc/examples/ganeti.cron \
228         doc/examples/ganeti.initd \
229         doc/examples/ganeti-master-role.ocf \
230         doc/examples/ganeti-node-role.ocf \
231         doc/examples/gnt-config-backup \
232         doc/examples/hooks/ipsec
233
234 nodist_pkgpython_PYTHON = \
235         $(BUILT_PYTHON_SOURCES)
236
237 noinst_PYTHON = \
238         lib/build/__init__.py \
239         lib/build/shell_example_lexer.py \
240         lib/build/sphinx_ext.py
241
242 pkgpython_PYTHON = \
243         lib/__init__.py \
244         lib/asyncnotifier.py \
245         lib/backend.py \
246         lib/bdev.py \
247         lib/bootstrap.py \
248         lib/cli.py \
249         lib/cmdlib.py \
250         lib/compat.py \
251         lib/config.py \
252         lib/constants.py \
253         lib/daemon.py \
254         lib/errors.py \
255         lib/hooksmaster.py \
256         lib/ht.py \
257         lib/jqueue.py \
258         lib/jstore.py \
259         lib/locking.py \
260         lib/luxi.py \
261         lib/mcpu.py \
262         lib/netutils.py \
263         lib/objects.py \
264         lib/opcodes.py \
265         lib/outils.py \
266         lib/ovf.py \
267         lib/pathutils.py \
268         lib/qlang.py \
269         lib/query.py \
270         lib/rpc.py \
271         lib/rpc_defs.py \
272         lib/runtime.py \
273         lib/serializer.py \
274         lib/ssconf.py \
275         lib/ssh.py \
276         lib/storage.py \
277         lib/uidpool.py \
278         lib/vcluster.py \
279         lib/network.py \
280         lib/workerpool.py
281
282 client_PYTHON = \
283         lib/client/__init__.py \
284         lib/client/gnt_backup.py \
285         lib/client/gnt_cluster.py \
286         lib/client/gnt_debug.py \
287         lib/client/gnt_group.py \
288         lib/client/gnt_instance.py \
289         lib/client/gnt_job.py \
290         lib/client/gnt_node.py \
291         lib/client/gnt_network.py \
292         lib/client/gnt_os.py \
293         lib/client/gnt_storage.py
294
295 hypervisor_PYTHON = \
296         lib/hypervisor/__init__.py \
297         lib/hypervisor/hv_base.py \
298         lib/hypervisor/hv_chroot.py \
299         lib/hypervisor/hv_fake.py \
300         lib/hypervisor/hv_kvm.py \
301         lib/hypervisor/hv_lxc.py \
302         lib/hypervisor/hv_xen.py
303
304 rapi_PYTHON = \
305         lib/rapi/__init__.py \
306         lib/rapi/baserlib.py \
307         lib/rapi/client.py \
308         lib/rapi/client_utils.py \
309         lib/rapi/connector.py \
310         lib/rapi/rlib2.py \
311         lib/rapi/testutils.py
312
313 http_PYTHON = \
314         lib/http/__init__.py \
315         lib/http/auth.py \
316         lib/http/client.py \
317         lib/http/server.py
318
319 confd_PYTHON = \
320         lib/confd/__init__.py \
321         lib/confd/client.py
322
323 masterd_PYTHON = \
324         lib/masterd/__init__.py \
325         lib/masterd/iallocator.py \
326         lib/masterd/instance.py
327
328 impexpd_PYTHON = \
329         lib/impexpd/__init__.py
330
331 watcher_PYTHON = \
332         lib/watcher/__init__.py \
333         lib/watcher/nodemaint.py \
334         lib/watcher/state.py
335
336 server_PYTHON = \
337         lib/server/__init__.py \
338         lib/server/masterd.py \
339         lib/server/noded.py \
340         lib/server/rapi.py
341
342 pytools_PYTHON = \
343         lib/tools/__init__.py \
344         lib/tools/burnin.py \
345         lib/tools/ensure_dirs.py \
346         lib/tools/node_cleanup.py \
347         lib/tools/node_daemon_setup.py \
348         lib/tools/prepare_node_join.py
349
350 utils_PYTHON = \
351         lib/utils/__init__.py \
352         lib/utils/algo.py \
353         lib/utils/filelock.py \
354         lib/utils/hash.py \
355         lib/utils/io.py \
356         lib/utils/log.py \
357         lib/utils/lvm.py \
358         lib/utils/mlock.py \
359         lib/utils/nodesetup.py \
360         lib/utils/process.py \
361         lib/utils/retry.py \
362         lib/utils/text.py \
363         lib/utils/wrapper.py \
364         lib/utils/x509.py
365
366 docinput = \
367         doc/conf.py \
368         doc/css/style.css \
369         doc/admin.rst \
370         doc/cluster-merge.rst \
371         doc/design-2.0.rst \
372         doc/design-2.1.rst \
373         doc/design-2.2.rst \
374         doc/design-2.3.rst \
375         doc/design-2.4.rst \
376         doc/design-2.5.rst \
377         doc/design-2.6.rst \
378         doc/design-2.7.rst \
379         doc/design-autorepair.rst \
380         doc/design-bulk-create.rst \
381         doc/design-chained-jobs.rst \
382         doc/design-cpu-pinning.rst \
383         doc/design-draft.rst \
384         doc/design-htools-2.3.rst \
385         doc/design-http-server.rst \
386         doc/design-impexp2.rst \
387         doc/design-lu-generated-jobs.rst \
388         doc/design-linuxha.rst \
389         doc/design-multi-reloc.rst \
390         doc/design-network.rst \
391         doc/design-node-add.rst \
392         doc/design-oob.rst \
393         doc/design-ovf-support.rst \
394         doc/design-opportunistic-locking.rst \
395         doc/design-partitioned.rst \
396         doc/design-query-splitting.rst \
397         doc/design-query2.rst \
398         doc/design-resource-model.rst \
399         doc/design-restricted-commands.rst \
400         doc/design-shared-storage.rst \
401         doc/design-monitoring-agent.rst \
402         doc/design-virtual-clusters.rst \
403         doc/design-x509-ca.rst \
404         doc/devnotes.rst \
405         doc/glossary.rst \
406         doc/hooks.rst \
407         doc/iallocator.rst \
408         doc/index.rst \
409         doc/install-quick.rst \
410         doc/install.rst \
411         doc/locking.rst \
412         doc/manpages-disabled.rst \
413         doc/move-instance.rst \
414         doc/news.rst \
415         doc/ovfconverter.rst \
416         doc/rapi.rst \
417         doc/security.rst \
418         doc/upgrade.rst \
419         doc/virtual-cluster.rst \
420         doc/walkthrough.rst
421
422 # Generates file names such as "doc/man-gnt-instance.rst"
423 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
424
425 # Haskell programs to be installed in $PREFIX/bin
426 HS_BIN_PROGS=src/htools
427
428 # Haskell programs to be installed in the MYEXECLIB dir
429 if ENABLE_MONITORING
430 HS_MYEXECLIB_PROGS=src/mon-collector
431 else
432 HS_MYEXECLIB_PROGS=
433 endif
434
435 # Haskell programs to compiled but not installed automatically
436 # Usually they have their own specific installation rules
437 HS_COMPILE_PROGS= \
438         src/hconfd \
439         src/rpc-test
440
441 # All Haskell non-test programs to be compiled but not automatically installed
442 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
443
444 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
445 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
446
447 HS_ALL_PROGS = \
448         $(HS_PROGS) \
449         test/hs/hpc-htools \
450         test/hs/hpc-mon-collector \
451         test/hs/htest \
452         $(HS_COMPILE_PROGS)
453
454 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
455 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
456
457 HFLAGS = \
458         -O -Wall -Werror -isrc \
459         -fwarn-monomorphism-restriction \
460         -fwarn-tabs \
461         $(GHC_BYVERSION_FLAGS)
462
463 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
464 HEXTRA =
465 # internal extra flags (used for test/hs/htest mainly)
466 HEXTRA_INT =
467 # exclude options for coverage reports
468 HPCEXCL = --exclude Main \
469         --exclude Ganeti.Constants \
470         --exclude Ganeti.HTools.QC \
471         --exclude Ganeti.THH \
472         --exclude Ganeti.Version \
473         --exclude Test.Ganeti.Attoparsec \
474         --exclude Test.Ganeti.TestCommon \
475         --exclude Test.Ganeti.TestHTools \
476         --exclude Test.Ganeti.TestHelper \
477         --exclude Test.Ganeti.TestImports \
478         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
479
480 HS_LIB_SRCS = \
481         src/Ganeti/Block/Drbd/Types.hs \
482         src/Ganeti/Block/Drbd/Parser.hs \
483         src/Ganeti/BasicTypes.hs \
484         src/Ganeti/Common.hs \
485         src/Ganeti/Compat.hs \
486         src/Ganeti/Confd/Client.hs \
487         src/Ganeti/Confd/Server.hs \
488         src/Ganeti/Confd/Types.hs \
489         src/Ganeti/Confd/Utils.hs \
490         src/Ganeti/Config.hs \
491         src/Ganeti/Daemon.hs \
492         src/Ganeti/DataCollectors/CLI.hs \
493         src/Ganeti/DataCollectors/Drbd.hs \
494         src/Ganeti/DataCollectors/Program.hs \
495         src/Ganeti/DataCollectors/Types.hs \
496         src/Ganeti/Errors.hs \
497         src/Ganeti/HTools/Backend/IAlloc.hs \
498         src/Ganeti/HTools/Backend/Luxi.hs \
499         src/Ganeti/HTools/Backend/Rapi.hs \
500         src/Ganeti/HTools/Backend/Simu.hs \
501         src/Ganeti/HTools/Backend/Text.hs \
502         src/Ganeti/HTools/CLI.hs \
503         src/Ganeti/HTools/Cluster.hs \
504         src/Ganeti/HTools/Container.hs \
505         src/Ganeti/HTools/ExtLoader.hs \
506         src/Ganeti/HTools/Graph.hs \
507         src/Ganeti/HTools/Group.hs \
508         src/Ganeti/HTools/Instance.hs \
509         src/Ganeti/HTools/Loader.hs \
510         src/Ganeti/HTools/Node.hs \
511         src/Ganeti/HTools/PeerMap.hs \
512         src/Ganeti/HTools/Program/Hail.hs \
513         src/Ganeti/HTools/Program/Hbal.hs \
514         src/Ganeti/HTools/Program/Hcheck.hs \
515         src/Ganeti/HTools/Program/Hinfo.hs \
516         src/Ganeti/HTools/Program/Hscan.hs \
517         src/Ganeti/HTools/Program/Hspace.hs \
518         src/Ganeti/HTools/Program/Hroller.hs \
519         src/Ganeti/HTools/Program/Main.hs \
520         src/Ganeti/HTools/Types.hs \
521         src/Ganeti/Hash.hs \
522         src/Ganeti/JQueue.hs \
523         src/Ganeti/JSON.hs \
524         src/Ganeti/Jobs.hs \
525         src/Ganeti/Logging.hs \
526         src/Ganeti/Luxi.hs \
527         src/Ganeti/Network.hs \
528         src/Ganeti/Objects.hs \
529         src/Ganeti/OpCodes.hs \
530         src/Ganeti/OpParams.hs \
531         src/Ganeti/Path.hs \
532         src/Ganeti/Query/Common.hs \
533         src/Ganeti/Query/Filter.hs \
534         src/Ganeti/Query/Group.hs \
535         src/Ganeti/Query/Job.hs \
536         src/Ganeti/Query/Language.hs \
537         src/Ganeti/Query/Node.hs \
538         src/Ganeti/Query/Query.hs \
539         src/Ganeti/Query/Server.hs \
540         src/Ganeti/Query/Types.hs \
541         src/Ganeti/Rpc.hs \
542         src/Ganeti/Runtime.hs \
543         src/Ganeti/Ssconf.hs \
544         src/Ganeti/THH.hs \
545         src/Ganeti/Types.hs \
546         src/Ganeti/Utils.hs
547
548 HS_TEST_SRCS = \
549         test/hs/Test/Ganeti/Attoparsec.hs \
550         test/hs/Test/Ganeti/BasicTypes.hs \
551         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
552         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
553         test/hs/Test/Ganeti/Common.hs \
554         test/hs/Test/Ganeti/Confd/Types.hs \
555         test/hs/Test/Ganeti/Confd/Utils.hs \
556         test/hs/Test/Ganeti/Daemon.hs \
557         test/hs/Test/Ganeti/Errors.hs \
558         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
559         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
560         test/hs/Test/Ganeti/HTools/CLI.hs \
561         test/hs/Test/Ganeti/HTools/Cluster.hs \
562         test/hs/Test/Ganeti/HTools/Container.hs \
563         test/hs/Test/Ganeti/HTools/Graph.hs \
564         test/hs/Test/Ganeti/HTools/Instance.hs \
565         test/hs/Test/Ganeti/HTools/Loader.hs \
566         test/hs/Test/Ganeti/HTools/Node.hs \
567         test/hs/Test/Ganeti/HTools/PeerMap.hs \
568         test/hs/Test/Ganeti/HTools/Types.hs \
569         test/hs/Test/Ganeti/JSON.hs \
570         test/hs/Test/Ganeti/Jobs.hs \
571         test/hs/Test/Ganeti/JQueue.hs \
572         test/hs/Test/Ganeti/Luxi.hs \
573         test/hs/Test/Ganeti/Network.hs \
574         test/hs/Test/Ganeti/Objects.hs \
575         test/hs/Test/Ganeti/OpCodes.hs \
576         test/hs/Test/Ganeti/Query/Filter.hs \
577         test/hs/Test/Ganeti/Query/Language.hs \
578         test/hs/Test/Ganeti/Query/Query.hs \
579         test/hs/Test/Ganeti/Rpc.hs \
580         test/hs/Test/Ganeti/Runtime.hs \
581         test/hs/Test/Ganeti/Ssconf.hs \
582         test/hs/Test/Ganeti/THH.hs \
583         test/hs/Test/Ganeti/TestCommon.hs \
584         test/hs/Test/Ganeti/TestHTools.hs \
585         test/hs/Test/Ganeti/TestHelper.hs \
586         test/hs/Test/Ganeti/Types.hs \
587         test/hs/Test/Ganeti/Utils.hs
588
589 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
590
591 HS_BUILT_SRCS = \
592         test/hs/Test/Ganeti/TestImports.hs \
593         src/Ganeti/Constants.hs \
594         src/Ganeti/Version.hs
595 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
596
597 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
598
599 $(RUN_IN_TEMPDIR): | stamp-directories
600
601 doc/html/index.html: ENABLE_MANPAGES =
602 doc/man-html/index.html: ENABLE_MANPAGES = 1
603 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
604
605 # Note: we use here an order-only prerequisite, as the contents of
606 # _autoconf.py are not actually influencing the html build output: it
607 # has to exist in order for the sphinx module to be loaded
608 # successfully, but we certainly don't want the docs to be rebuilt if
609 # it changes
610 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
611         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
612         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
613         doc/css/style.css \
614         | $(BUILT_PYTHON_SOURCES)
615         @test -n "$(SPHINX)" || \
616             { echo 'sphinx-build' not found during configure; exit 1; }
617 if !MANPAGES_IN_DOC
618         if test -n '$(ENABLE_MANPAGES)'; then \
619           echo 'Man pages in documentation were disabled at configure time' >&2; \
620           exit 1; \
621         fi
622 endif
623 ## Sphinx provides little control over what content should be included. Some
624 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
625 ## build two different versions of the documentation--once without man pages and
626 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
627 ## us with this, but requires running in a temporary directory. It moves the
628 ## correct files into place depending on environment variables.
629         dir=$(dir $@) && \
630         @mkdir_p@ $$dir && \
631         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
632         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
633             -d . \
634             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
635             -D release="$(PACKAGE_VERSION)" \
636             -D graphviz_dot="$(DOT)" \
637             -D enable_manpages="$(ENABLE_MANPAGES)" \
638             doc $(CURDIR)/$$dir && \
639         rm -f $$dir/.buildinfo $$dir/objects.inv
640         touch $@
641
642 doc/html: doc/html/index.html
643
644 doc/man-html: doc/man-html/index.html
645
646 doc/install-quick.rst: INSTALL
647 doc/news.rst: NEWS
648 doc/upgrade.rst: UPGRADE
649
650 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
651         set -e; \
652         { echo '.. This file is automatically updated at build time from $<.'; \
653           echo '.. Do not edit.'; \
654           echo; \
655           cat $<; \
656         } > $@
657
658 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
659         { echo '.. This file is automatically generated, do not edit!'; \
660           echo ''; \
661           echo 'Man pages'; \
662           echo '========='; \
663           echo; \
664           echo '.. toctree::'; \
665           echo '   :maxdepth: 1'; \
666           echo; \
667           for i in $(notdir $(mandocrst)); do \
668             echo "   $$i"; \
669           done | LC_ALL=C sort; \
670         } > $@
671
672 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
673 if MANPAGES_IN_DOC
674         { echo '.. This file is automatically updated at build time from $<.'; \
675           echo '.. Do not edit.'; \
676           echo; \
677           echo "$*"; \
678           echo '=========================================='; \
679           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
680         } > $@
681 else
682         echo 'Man pages in documentation were disabled at configure time' >&2; \
683         exit 1;
684 endif
685
686 # Things to build but not to install (add it to EXTRA_DIST if it should be
687 # distributed)
688 noinst_DATA = \
689         doc/html \
690         $(BUILT_EXAMPLES) \
691         doc/examples/bash_completion \
692         doc/examples/bash_completion-debug \
693         $(manhtml)
694
695 if MANPAGES_IN_DOC
696 noinst_DATA += doc/man-html
697 endif
698
699 gnt_scripts = \
700         scripts/gnt-backup \
701         scripts/gnt-cluster \
702         scripts/gnt-debug \
703         scripts/gnt-group \
704         scripts/gnt-instance \
705         scripts/gnt-job \
706         scripts/gnt-network \
707         scripts/gnt-node \
708         scripts/gnt-os \
709         scripts/gnt-storage
710
711 PYTHON_BOOTSTRAP_SBIN = \
712         daemons/ganeti-masterd \
713         daemons/ganeti-noded \
714         daemons/ganeti-rapi \
715         daemons/ganeti-watcher \
716         $(gnt_scripts)
717
718 PYTHON_BOOTSTRAP = \
719         $(PYTHON_BOOTSTRAP_SBIN) \
720         tools/burnin \
721         tools/ensure-dirs \
722         tools/node-cleanup \
723         tools/node-daemon-setup \
724         tools/prepare-node-join
725
726 qa_scripts = \
727         qa/__init__.py \
728         qa/ganeti-qa.py \
729         qa/qa_cluster.py \
730         qa/qa_config.py \
731         qa/qa_daemon.py \
732         qa/qa_env.py \
733         qa/qa_error.py \
734         qa/qa_group.py \
735         qa/qa_instance.py \
736         qa/qa_job.py \
737         qa/qa_node.py \
738         qa/qa_os.py \
739         qa/qa_rapi.py \
740         qa/qa_tags.py \
741         qa/qa_utils.py
742
743 bin_SCRIPTS =
744 if WANT_HTOOLS
745 bin_SCRIPTS += $(HS_BIN_PROGS)
746 install-exec-hook:
747         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
748 # FIXME: this is a hardcoded logic, instead of auto-resolving
749         $(LN_S) -f ../../../bin/htools \
750           $(DESTDIR)$(iallocatorsdir)/hail
751         for role in $(HS_BIN_ROLES); do \
752           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
753         done
754 endif
755
756 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
757         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
758           echo "Error: cannot run unittests without the development" \
759                " libraries (see devnotes.rst)" 1>&2; \
760           exit 1; \
761         fi
762         @rm -f $(notdir $@).tix
763         $(GHC) --make \
764           $(HFLAGS) \
765           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
766           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
767           $(HEXTRA) $(HEXTRA_INT) $@
768         @touch "$@"
769
770 # for the test/hs/htest binary, we need to enable profiling/coverage
771 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
772
773 # we compile the hpc-htools binary with the program coverage
774 test/hs/hpc-htools: HEXTRA_INT=-fhpc
775
776 # we compile the hpc-mon-collector binary with the program coverage
777 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
778
779 # test dependency
780 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
781
782 # rules for building profiling-enabled versions of the haskell
783 # programs: hs-prof does the full two-step build, whereas
784 # hs-prof-quick does only the final rebuild (hs-prof must have been
785 # run before)
786 .PHONY: hs-prof hs-prof-quick
787 hs-prof:
788         @if [ -z "$(TARGET)" ]; then \
789           echo "You need to define TARGET when running this rule" 1>&2; \
790           exit 1; \
791         fi
792         $(MAKE) $(AM_MAKEFLAGS) clean
793         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
794         rm -f $(HS_ALL_PROGS)
795         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
796
797 hs-prof-quick:
798         @if [ -z "$(TARGET)" ]; then \
799           echo "You need to define TARGET when running this rule" 1>&2; \
800           exit 1; \
801         fi
802         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
803
804 dist_sbin_SCRIPTS = \
805         tools/ganeti-listrunner
806
807 nodist_sbin_SCRIPTS = \
808         $(PYTHON_BOOTSTRAP_SBIN) \
809         daemons/ganeti-cleaner
810
811 if ENABLE_CONFD
812 src/ganeti-confd: src/hconfd
813         cp -f $< $@
814
815 nodist_sbin_SCRIPTS += src/ganeti-confd
816 endif
817
818 python_scripts = \
819         tools/cfgshell \
820         tools/cfgupgrade \
821         tools/cfgupgrade12 \
822         tools/cluster-merge \
823         tools/confd-client \
824         tools/fmtjson \
825         tools/lvmstrap \
826         tools/move-instance \
827         tools/ovfconverter \
828         tools/sanitize-config
829
830 dist_tools_SCRIPTS = \
831         $(python_scripts) \
832         tools/burnin \
833         tools/kvm-console-wrapper \
834         tools/master-ip-setup \
835         tools/xen-console-wrapper
836
837 nodist_tools_python_scripts = \
838         tools/node-cleanup
839
840 nodist_tools_SCRIPTS = \
841         $(nodist_tools_python_scripts) \
842         tools/users-setup \
843         tools/vcluster-setup
844
845 pkglib_python_scripts = \
846         daemons/import-export \
847         tools/check-cert-expired
848
849 nodist_pkglib_python_scripts = \
850         tools/ensure-dirs \
851         tools/node-daemon-setup \
852         tools/prepare-node-join
853
854 myexeclib_SCRIPTS = \
855         daemons/daemon-util \
856         tools/kvm-ifup \
857         $(pkglib_python_scripts) \
858         $(HS_MYEXECLIB_PROGS)
859
860 nodist_myexeclib_SCRIPTS = \
861         $(nodist_pkglib_python_scripts)
862
863 EXTRA_DIST = \
864         NEWS \
865         UPGRADE \
866         epydoc.conf.in \
867         pylintrc \
868         autotools/build-bash-completion \
869         autotools/build-rpc \
870         autotools/check-header \
871         autotools/check-imports \
872         autotools/check-man-dashes \
873         autotools/check-man-references \
874         autotools/check-man-warnings \
875         autotools/check-news \
876         autotools/check-python-code \
877         autotools/check-tar \
878         autotools/check-version \
879         autotools/convert-constants \
880         autotools/docpp \
881         autotools/gen-py-coverage \
882         autotools/sphinx-wrapper \
883         autotools/testrunner \
884         autotools/wrong-hardcoded-paths \
885         $(RUN_IN_TEMPDIR) \
886         daemons/daemon-util.in \
887         daemons/ganeti-cleaner.in \
888         $(pkglib_python_scripts) \
889         devel/upload \
890         devel/webserver \
891         tools/kvm-ifup.in \
892         tools/users-setup.in \
893         tools/vcluster-setup.in \
894         $(docinput) \
895         doc/html \
896         $(BUILT_EXAMPLES:%=%.in) \
897         doc/examples/ganeti.default \
898         doc/examples/ganeti.default-debug \
899         doc/examples/hooks/ethers \
900         doc/examples/gnt-debug/README \
901         doc/examples/gnt-debug/delay0.json \
902         doc/examples/gnt-debug/delay50.json \
903         test/py/lockperf.py \
904         test/py/testutils.py \
905         test/py/mocks.py \
906         $(dist_TESTS) \
907         $(TEST_FILES) \
908         man/footer.rst \
909         $(manrst) \
910         $(maninput) \
911         qa/qa-sample.json \
912         $(qa_scripts) \
913         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
914         $(HS_PROG_SRCS) \
915         src/lint-hints.hs \
916         test/hs/cli-tests-defs.sh \
917         test/hs/offline-test.sh \
918         .ghci
919
920 man_MANS = \
921         man/ganeti-cleaner.8 \
922         man/ganeti-confd.8 \
923         man/ganeti-listrunner.8 \
924         man/ganeti-masterd.8 \
925         man/ganeti-noded.8 \
926         man/ganeti-os-interface.7 \
927         man/ganeti-extstorage-interface.7 \
928         man/ganeti-rapi.8 \
929         man/ganeti-watcher.8 \
930         man/ganeti.7 \
931         man/gnt-backup.8 \
932         man/gnt-cluster.8 \
933         man/gnt-debug.8 \
934         man/gnt-group.8 \
935         man/gnt-network.8 \
936         man/gnt-instance.8 \
937         man/gnt-job.8 \
938         man/gnt-node.8 \
939         man/gnt-os.8 \
940         man/gnt-storage.8 \
941         man/hail.1 \
942         man/hbal.1 \
943         man/hcheck.1 \
944         man/hinfo.1 \
945         man/hscan.1 \
946         man/hspace.1 \
947         man/hroller.1 \
948         man/htools.1 \
949         man/mon-collector.7
950
951 # Remove extensions from all filenames in man_MANS
952 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
953
954 manrst = $(patsubst %,%.rst,$(mannoext))
955 manhtml = $(patsubst %.rst,%.html,$(manrst))
956 mangen = $(patsubst %.rst,%.gen,$(manrst))
957 maninput = \
958         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
959         $(patsubst %.html,%.html.in,$(manhtml)) \
960         $(mangen)
961
962 TEST_FILES = \
963         test/data/htools/clean-nonzero-score.data \
964         test/data/htools/common-suffix.data \
965         test/data/htools/empty-cluster.data \
966         test/data/htools/hail-alloc-drbd.json \
967         test/data/htools/hail-alloc-invalid-twodisks.json \
968         test/data/htools/hail-alloc-twodisks.json \
969         test/data/htools/hail-change-group.json \
970         test/data/htools/hail-invalid-reloc.json \
971         test/data/htools/hail-node-evac.json \
972         test/data/htools/hail-reloc-drbd.json \
973         test/data/htools/hbal-excl-tags.data \
974         test/data/htools/hbal-split-insts.data \
975         test/data/htools/hspace-tiered-ipolicy.data \
976         test/data/htools/invalid-node.data \
977         test/data/htools/missing-resources.data \
978         test/data/htools/n1-failure.data \
979         test/data/htools/rapi/groups.json \
980         test/data/htools/rapi/info.json \
981         test/data/htools/rapi/instances.json \
982         test/data/htools/rapi/nodes.json \
983         test/hs/shelltests/htools-balancing.test \
984         test/hs/shelltests/htools-basic.test \
985         test/hs/shelltests/htools-dynutil.test \
986         test/hs/shelltests/htools-excl.test \
987         test/hs/shelltests/htools-hail.test \
988         test/hs/shelltests/htools-hspace.test \
989         test/hs/shelltests/htools-invalid.test \
990         test/hs/shelltests/htools-multi-group.test \
991         test/hs/shelltests/htools-no-backend.test \
992         test/hs/shelltests/htools-rapi.test \
993         test/hs/shelltests/htools-single-group.test \
994         test/hs/shelltests/htools-text-backend.test \
995         test/hs/shelltests/htools-mon-collector.test \
996         test/data/bdev-drbd-8.0.txt \
997         test/data/bdev-drbd-8.3.txt \
998         test/data/bdev-drbd-disk.txt \
999         test/data/bdev-drbd-net-ip4.txt \
1000         test/data/bdev-drbd-net-ip6.txt \
1001         test/data/bdev-rbd/json_output_empty.txt \
1002         test/data/bdev-rbd/json_output_extra_matches.txt \
1003         test/data/bdev-rbd/json_output_no_matches.txt \
1004         test/data/bdev-rbd/json_output_ok.txt \
1005         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1006         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1007         test/data/bdev-rbd/plain_output_new_ok.txt \
1008         test/data/bdev-rbd/plain_output_old_empty.txt \
1009         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1010         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1011         test/data/bdev-rbd/plain_output_old_ok.txt \
1012         test/data/bdev-rbd/output_invalid.txt \
1013         test/data/cert1.pem \
1014         test/data/cert2.pem \
1015         test/data/instance-minor-pairing.txt \
1016         test/data/ip-addr-show-dummy0.txt \
1017         test/data/ip-addr-show-lo-ipv4.txt \
1018         test/data/ip-addr-show-lo-ipv6.txt \
1019         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1020         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1021         test/data/ip-addr-show-lo-oneline.txt \
1022         test/data/ip-addr-show-lo.txt \
1023         test/data/kvm_0.12.5_help.txt \
1024         test/data/kvm_0.15.90_help.txt \
1025         test/data/kvm_0.9.1_help.txt \
1026         test/data/kvm_0.9.1_help_boot_test.txt \
1027         test/data/kvm_1.0_help.txt \
1028         test/data/kvm_1.1.2_help.txt \
1029         test/data/ovfdata/compr_disk.vmdk.gz \
1030         test/data/ovfdata/config.ini \
1031         test/data/ovfdata/corrupted_resources.ovf \
1032         test/data/ovfdata/empty.ini \
1033         test/data/ovfdata/empty.ovf \
1034         test/data/ovfdata/ganeti.mf \
1035         test/data/ovfdata/ganeti.ovf \
1036         test/data/ovfdata/gzip_disk.ovf \
1037         test/data/ovfdata/new_disk.vmdk \
1038         test/data/ovfdata/no_disk.ini \
1039         test/data/ovfdata/no_disk_in_ref.ovf \
1040         test/data/ovfdata/no_os.ini \
1041         test/data/ovfdata/no_ovf.ova \
1042         test/data/ovfdata/other/rawdisk.raw \
1043         test/data/ovfdata/ova.ova \
1044         test/data/ovfdata/rawdisk.raw \
1045         test/data/ovfdata/second_disk.vmdk \
1046         test/data/ovfdata/unsafe_path.ini \
1047         test/data/ovfdata/virtualbox.ovf \
1048         test/data/ovfdata/wrong_config.ini \
1049         test/data/ovfdata/wrong_extension.ovd \
1050         test/data/ovfdata/wrong_manifest.mf \
1051         test/data/ovfdata/wrong_manifest.ovf \
1052         test/data/ovfdata/wrong_ova.ova \
1053         test/data/ovfdata/wrong_xml.ovf \
1054         test/data/proc_drbd8.txt \
1055         test/data/proc_drbd80-emptyline.txt \
1056         test/data/proc_drbd83.txt \
1057         test/data/proc_drbd83_sync.txt \
1058         test/data/proc_drbd83_sync_want.txt \
1059         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1060         test/data/sys_drbd_usermode_helper.txt \
1061         test/data/vgreduce-removemissing-2.02.02.txt \
1062         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1063         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1064         test/data/vgs-missing-pvs-2.02.02.txt \
1065         test/data/vgs-missing-pvs-2.02.66.txt \
1066         test/py/ganeti-cli.test \
1067         test/py/gnt-cli.test \
1068         test/py/import-export_unittest-helper
1069
1070 python_tests = \
1071         doc/examples/rapi_testutils.py \
1072         test/py/cfgupgrade_unittest.py \
1073         test/py/docs_unittest.py \
1074         test/py/ganeti.asyncnotifier_unittest.py \
1075         test/py/ganeti.backend_unittest-runasroot.py \
1076         test/py/ganeti.backend_unittest.py \
1077         test/py/ganeti.bdev_unittest.py \
1078         test/py/ganeti.cli_unittest.py \
1079         test/py/ganeti.client.gnt_cluster_unittest.py \
1080         test/py/ganeti.client.gnt_instance_unittest.py \
1081         test/py/ganeti.client.gnt_job_unittest.py \
1082         test/py/ganeti.cmdlib_unittest.py \
1083         test/py/ganeti.compat_unittest.py \
1084         test/py/ganeti.confd.client_unittest.py \
1085         test/py/ganeti.config_unittest.py \
1086         test/py/ganeti.constants_unittest.py \
1087         test/py/ganeti.daemon_unittest.py \
1088         test/py/ganeti.errors_unittest.py \
1089         test/py/ganeti.hooks_unittest.py \
1090         test/py/ganeti.ht_unittest.py \
1091         test/py/ganeti.http_unittest.py \
1092         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1093         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1094         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1095         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1096         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1097         test/py/ganeti.hypervisor_unittest.py \
1098         test/py/ganeti.impexpd_unittest.py \
1099         test/py/ganeti.jqueue_unittest.py \
1100         test/py/ganeti.jstore_unittest.py \
1101         test/py/ganeti.locking_unittest.py \
1102         test/py/ganeti.luxi_unittest.py \
1103         test/py/ganeti.masterd.iallocator_unittest.py \
1104         test/py/ganeti.masterd.instance_unittest.py \
1105         test/py/ganeti.mcpu_unittest.py \
1106         test/py/ganeti.netutils_unittest.py \
1107         test/py/ganeti.objects_unittest.py \
1108         test/py/ganeti.opcodes_unittest.py \
1109         test/py/ganeti.outils_unittest.py \
1110         test/py/ganeti.ovf_unittest.py \
1111         test/py/ganeti.qlang_unittest.py \
1112         test/py/ganeti.query_unittest.py \
1113         test/py/ganeti.rapi.baserlib_unittest.py \
1114         test/py/ganeti.rapi.client_unittest.py \
1115         test/py/ganeti.rapi.resources_unittest.py \
1116         test/py/ganeti.rapi.rlib2_unittest.py \
1117         test/py/ganeti.rapi.testutils_unittest.py \
1118         test/py/ganeti.rpc_unittest.py \
1119         test/py/ganeti.runtime_unittest.py \
1120         test/py/ganeti.serializer_unittest.py \
1121         test/py/ganeti.server.rapi_unittest.py \
1122         test/py/ganeti.ssconf_unittest.py \
1123         test/py/ganeti.ssh_unittest.py \
1124         test/py/ganeti.storage_unittest.py \
1125         test/py/ganeti.tools.burnin_unittest.py \
1126         test/py/ganeti.tools.ensure_dirs_unittest.py \
1127         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1128         test/py/ganeti.tools.prepare_node_join_unittest.py \
1129         test/py/ganeti.uidpool_unittest.py \
1130         test/py/ganeti.utils.algo_unittest.py \
1131         test/py/ganeti.utils.filelock_unittest.py \
1132         test/py/ganeti.utils.hash_unittest.py \
1133         test/py/ganeti.utils.io_unittest-runasroot.py \
1134         test/py/ganeti.utils.io_unittest.py \
1135         test/py/ganeti.utils.log_unittest.py \
1136         test/py/ganeti.utils.lvm_unittest.py \
1137         test/py/ganeti.utils.mlock_unittest.py \
1138         test/py/ganeti.utils.nodesetup_unittest.py \
1139         test/py/ganeti.utils.process_unittest.py \
1140         test/py/ganeti.utils.retry_unittest.py \
1141         test/py/ganeti.utils.text_unittest.py \
1142         test/py/ganeti.utils.wrapper_unittest.py \
1143         test/py/ganeti.utils.x509_unittest.py \
1144         test/py/ganeti.utils_unittest.py \
1145         test/py/ganeti.vcluster_unittest.py \
1146         test/py/ganeti.workerpool_unittest.py \
1147         test/py/pycurl_reset_unittest.py \
1148         test/py/qa.qa_config_unittest.py \
1149         test/py/tempfile_fork_unittest.py
1150
1151 haskell_tests = test/hs/htest
1152
1153 dist_TESTS = \
1154         test/py/check-cert-expired_unittest.bash \
1155         test/py/daemon-util_unittest.bash \
1156         test/py/ganeti-cleaner_unittest.bash \
1157         test/py/import-export_unittest.bash \
1158         test/py/cli-test.bash \
1159         test/py/bash_completion.bash \
1160         $(python_tests)
1161
1162 nodist_TESTS =
1163 check_SCRIPTS =
1164
1165 if WANT_HSTESTS
1166 nodist_TESTS += $(haskell_tests)
1167 dist_TESTS += test/hs/offline-test.sh
1168 check_SCRIPTS += \
1169         test/hs/hpc-htools \
1170         test/hs/hpc-mon-collector \
1171         $(HS_BUILT_TEST_HELPERS)
1172 endif
1173
1174 TESTS = $(dist_TESTS) $(nodist_TESTS)
1175
1176 # Environment for all tests
1177 PLAIN_TESTS_ENVIRONMENT = \
1178         PYTHONPATH=. \
1179         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1180         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1181         $(RUN_IN_TEMPDIR)
1182
1183 # Environment for tests run by automake
1184 TESTS_ENVIRONMENT = \
1185         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1186
1187 all_python_code = \
1188         $(dist_sbin_SCRIPTS) \
1189         $(python_scripts) \
1190         $(pkglib_python_scripts) \
1191         $(nodist_pkglib_python_scripts) \
1192         $(nodist_tools_python_scripts) \
1193         $(python_tests) \
1194         $(pkgpython_PYTHON) \
1195         $(client_PYTHON) \
1196         $(hypervisor_PYTHON) \
1197         $(rapi_PYTHON) \
1198         $(server_PYTHON) \
1199         $(pytools_PYTHON) \
1200         $(http_PYTHON) \
1201         $(confd_PYTHON) \
1202         $(masterd_PYTHON) \
1203         $(impexpd_PYTHON) \
1204         $(utils_PYTHON) \
1205         $(watcher_PYTHON) \
1206         $(noinst_PYTHON) \
1207         $(qa_scripts)
1208
1209 srclink_files = \
1210         man/footer.rst \
1211         test/py/check-cert-expired_unittest.bash \
1212         test/py/daemon-util_unittest.bash \
1213         test/py/ganeti-cleaner_unittest.bash \
1214         test/py/import-export_unittest.bash \
1215         test/py/cli-test.bash \
1216         test/py/bash_completion.bash \
1217         test/hs/offline-test.sh \
1218         test/hs/cli-tests-defs.sh \
1219         $(all_python_code) \
1220         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1221         $(docinput)
1222
1223 check_python_code = \
1224         $(BUILD_BASH_COMPLETION) \
1225         $(CHECK_IMPORTS) \
1226         $(CHECK_HEADER) \
1227         $(DOCPP) \
1228         $(all_python_code)
1229
1230 lint_python_code = \
1231         ganeti \
1232         ganeti/http/server.py \
1233         $(dist_sbin_SCRIPTS) \
1234         $(python_scripts) \
1235         $(pkglib_python_scripts) \
1236         $(BUILD_BASH_COMPLETION) \
1237         $(CHECK_IMPORTS) \
1238         $(CHECK_HEADER) \
1239         $(DOCPP) \
1240         $(PYTHON_BOOTSTRAP)
1241
1242 standalone_python_modules = \
1243         lib/rapi/client.py \
1244         tools/ganeti-listrunner
1245
1246 pep8_python_code = \
1247         ganeti \
1248         ganeti/http/server.py \
1249         $(dist_sbin_SCRIPTS) \
1250         $(python_scripts) \
1251         $(pkglib_python_scripts) \
1252         $(BUILD_BASH_COMPLETION) \
1253         $(CHECK_HEADER) \
1254         $(DOCPP) \
1255         $(PYTHON_BOOTSTRAP) \
1256         qa
1257
1258 test/py/daemon-util_unittest.bash: daemons/daemon-util
1259
1260 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1261
1262 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1263
1264 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1265         sed -f $(REPLACE_VARS_SED) < $< > $@
1266         chmod +x $@
1267
1268 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1269         sed -f $(REPLACE_VARS_SED) < $< > $@
1270         chmod +x $@
1271
1272 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1273         sed -f $(REPLACE_VARS_SED) < $< > $@
1274         chmod +x $@
1275
1276 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1277         sed -f $(REPLACE_VARS_SED) < $< > $@
1278         chmod +x $@
1279
1280 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1281         sed -f $(REPLACE_VARS_SED) < $< > $@
1282
1283 doc/examples/bash_completion: BC_ARGS = --compact
1284 doc/examples/bash_completion-debug: BC_ARGS =
1285
1286 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1287         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1288         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1289         daemons/ganeti-cleaner \
1290         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1291         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1292           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1293
1294 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1295         lib/build/shell_example_lexer.py \
1296         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1297         @echo "Checking $< for hardcoded paths..."
1298         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1299           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1300           exit 1; \
1301         fi
1302         set -e ; \
1303         trap 'echo auto-removing $@; rm $@' EXIT; \
1304         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1305         $(CHECK_MAN_REFERENCES) $@; \
1306         trap - EXIT
1307
1308 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1309         @test -n "$(PANDOC)" || \
1310           { echo 'pandoc' not found during configure; exit 1; }
1311         set -o pipefail -e; \
1312         trap 'echo auto-removing $@; rm $@' EXIT; \
1313         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1314           sed -e 's/\\@/@/g' > $@; \
1315         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1316         $(CHECK_MAN_DASHES) $@; \
1317         trap - EXIT
1318
1319 man/%.html.in: man/%.gen man/footer.rst
1320         @test -n "$(PANDOC)" || \
1321           { echo 'pandoc' not found during configure; exit 1; }
1322         set -o pipefail ; \
1323         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1324           sed -e 's/\\@/@/g' > $@
1325
1326 man/%: man/%.in  $(REPLACE_VARS_SED)
1327         sed -f $(REPLACE_VARS_SED) < $< > $@
1328
1329 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1330         sed -f $(REPLACE_VARS_SED) < $< > $@
1331
1332 vcs-version:
1333         if test -d .git; then \
1334           git describe > $@; \
1335         elif test ! -f $@ ; then \
1336           echo "Cannot auto-generate $@ file"; exit 1; \
1337         fi
1338
1339 .PHONY: clean-vcs-version
1340 clean-vcs-version:
1341         rm -f vcs-version
1342
1343 .PHONY: regen-vcs-version
1344 regen-vcs-version:
1345         @set -e; \
1346         cd $(srcdir); \
1347         if test -d .git; then \
1348           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1349           git describe > $$T; \
1350           if ! cmp --quiet $$T vcs-version; then \
1351             mv $$T vcs-version; \
1352           fi; \
1353         fi
1354
1355 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1356         vcs-version $(built_base_sources)
1357         set -e; \
1358         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1359         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1360
1361 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1362         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1363         lib/jstore.py $(RUN_IN_TEMPDIR) \
1364         $(CONVERT_CONSTANTS) $(built_base_sources) \
1365         | lib/_vcsversion.py
1366         set -e; \
1367         { cat $< ; \
1368           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1369         } > $@
1370
1371 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1372         $(built_base_sources)
1373         set -e; \
1374         { cat $< ; \
1375           echo ; \
1376           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1377             echo "import $$name ()" ; \
1378           done ; \
1379         } > $@
1380
1381 lib/_autoconf.py: Makefile | stamp-directories
1382         set -e; \
1383         { echo '# This file is automatically generated, do not edit!'; \
1384           echo '#'; \
1385           echo ''; \
1386           echo '"""Build-time configuration for Ganeti.'; \
1387           echo '';\
1388           echo 'This file is autogenerated by the build process.'; \
1389           echo 'For any changes you need to re-run ./configure (and'; \
1390           echo 'not edit by hand).'; \
1391           echo ''; \
1392           echo '"""'; \
1393           echo ''; \
1394           echo '# pylint: disable=C0301,C0324'; \
1395           echo '# because this is autogenerated, we do not want'; \
1396           echo '# style warnings' ; \
1397           echo ''; \
1398           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1399           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1400           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1401           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1402           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1403           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1404           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1405           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1406           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1407           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1408           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1409           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1410           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1411           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1412           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1413           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1414           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1415           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1416           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1417           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1418           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1419           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1420           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1421           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1422           echo "KVM_PATH = '$(KVM_PATH)'"; \
1423           echo "IP_PATH = '$(IP_PATH)'"; \
1424           echo "SOCAT_PATH = '$(SOCAT)'"; \
1425           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1426           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1427           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1428           echo "TOOLSDIR = '$(toolsdir)'"; \
1429           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1430           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1431           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1432           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1433           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1434           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1435           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1436           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1437           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1438           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1439           echo "RAPI_USER = '$(RAPI_USER)'"; \
1440           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1441           echo "CONFD_USER = '$(CONFD_USER)'"; \
1442           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1443           echo "NODED_USER = '$(NODED_USER)'"; \
1444           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1445           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1446           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1447           echo "HTOOLS = True"; \
1448           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1449           echo "XEN_CMD = '$(XEN_CMD)'"; \
1450           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1451           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1452           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1453 ## Write dictionary with man page name as the key and the section number as the
1454 ## value
1455           echo "MAN_PAGES = {"; \
1456           for i in $(notdir $(man_MANS)); do \
1457             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1458           done; \
1459           echo "}"; \
1460         } > $@
1461
1462 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1463         set -e; \
1464         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1465         { echo '# This file is automatically generated, do not edit!'; \
1466           echo '#'; \
1467           echo ''; \
1468           echo '"""Build-time VCS version number for Ganeti.'; \
1469           echo '';\
1470           echo 'This file is autogenerated by the build process.'; \
1471           echo 'For any changes you need to re-run ./configure (and'; \
1472           echo 'not edit by hand).'; \
1473           echo ''; \
1474           echo '"""'; \
1475           echo ''; \
1476           echo '# pylint: disable=C0301,C0324'; \
1477           echo '# because this is autogenerated, we do not want'; \
1478           echo '# style warnings' ; \
1479           echo ''; \
1480           echo "VCS_VERSION = '$$VCSVER'"; \
1481         } > $@
1482
1483 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1484         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1485
1486 $(SHELL_ENV_INIT): Makefile stamp-directories
1487         set -e; \
1488         { echo '# Allow overriding for tests'; \
1489           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1490           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1491           echo; \
1492           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1493           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1494           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1495           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1496           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1497         } > $@
1498
1499 ## Writes sed script to replace placeholders with build-time values. The
1500 ## additional quotes after the first @ sign are necessary to stop configure
1501 ## from replacing those values as well.
1502 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1503         set -e; \
1504         { echo 's#@''PREFIX@#$(prefix)#g'; \
1505           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1506           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1507           echo 's#@''BINDIR@#$(bindir)#g'; \
1508           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1509           echo 's#@''LIBDIR@#$(libdir)#g'; \
1510           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1511           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1512           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1513           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1514           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1515           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1516           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1517           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1518           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1519           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1520           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1521           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1522           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1523           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1524           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1525           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1526           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1527           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1528           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1529           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1530           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1531           echo; \
1532           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1533           echo '  r $(SHELL_ENV_INIT)'; \
1534           echo '  d'; \
1535           echo '}'; \
1536         } > $@
1537
1538 # Using deferred evaluation
1539 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1540 daemons/ganeti-watcher: MODULE = ganeti.watcher
1541 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1542 tools/burnin: MODULE = ganeti.tools.burnin
1543 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1544 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1545 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1546 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1547 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1548
1549 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1550         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1551         set -e; \
1552         { echo '#!/usr/bin/python'; \
1553           echo '# This file is automatically generated, do not edit!'; \
1554           echo "# Edit $(MODULE) instead."; \
1555           echo; \
1556           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1557           echo; \
1558           echo '# pylint: disable=C0103'; \
1559           echo '# C0103: Invalid name'; \
1560           echo; \
1561           echo 'import sys'; \
1562           echo 'import $(MODULE) as main'; \
1563           echo; \
1564           echo '# Temporarily alias commands until bash completion'; \
1565           echo '# generator is changed'; \
1566           echo 'if hasattr(main, "commands"):'; \
1567           echo '  commands = main.commands # pylint: disable=E1101'; \
1568           echo 'if hasattr(main, "aliases"):'; \
1569           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1570           echo; \
1571           echo 'if __name__ == "__main__":'; \
1572           echo '  sys.exit(main.Main())'; \
1573         } > $@
1574         chmod u+x $@
1575
1576 $(HS_BUILT_TEST_HELPERS): Makefile
1577         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1578         set -e; \
1579         { echo '#!/bin/sh'; \
1580           echo '# This file is automatically generated, do not edit!'; \
1581           echo "# Edit Makefile.am instead."; \
1582           echo; \
1583           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1584         } > $@
1585         chmod u+x $@
1586
1587 stamp-directories: Makefile
1588         $(MAKE) $(AM_MAKEFLAGS) ganeti
1589         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1590         touch $@
1591
1592 # We need to create symlinks because "make distcheck" will not install Python
1593 # files when building.
1594 stamp-srclinks: Makefile | stamp-directories
1595         set -e; \
1596         for i in $(srclink_files); do \
1597           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1598             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1599           fi; \
1600         done
1601         touch $@
1602
1603 .PHONY: ganeti
1604 ganeti:
1605         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1606
1607 .PHONY: check-dirs
1608 check-dirs: $(GENERATED_FILES)
1609         @set -e; \
1610         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1611           error=; \
1612           while read dir; do \
1613             case "$$dir" in \
1614               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1615               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1616             esac; \
1617           done; \
1618           for dir in $(DIRS); do \
1619             if ! test -d "$$dir"; then \
1620               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1621               error=1; \
1622             fi \
1623           done; \
1624           test -z "$$error"; \
1625         }
1626
1627 .PHONY: check-local
1628 check-local: check-dirs $(GENERATED_FILES)
1629         $(CHECK_PYTHON_CODE) $(check_python_code)
1630         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1631         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1632         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1633         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1634         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1635         error= ; \
1636         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1637           echo "Incorrect version in README, expected $$expver" >&2; \
1638           error=1; \
1639         fi; \
1640         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1641             doc/security.rst; do \
1642           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1643             "Documents Ganeti version $$expver"; then \
1644             echo "Incorrect version in $$file, expected $$expver" >&2; \
1645             error=1; \
1646           fi; \
1647         done; \
1648         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1649           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1650           error=1; \
1651         fi; \
1652         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1653           ".. Last updated for Ganeti $$expver"; then \
1654           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1655           error=1; \
1656         fi; \
1657         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1658           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1659             echo "Longest line in $$file is longer than 80 characters" >&2; \
1660             error=1; \
1661           fi; \
1662         done; \
1663         test -z "$$error"
1664
1665 .PHONY: hs-tests
1666 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1667         @rm -f htest.tix
1668         ./test/hs/htest
1669
1670 .PHONY: hs-shell
1671 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1672         @rm -f hpc-htools.tix hpc-mon-collector.tix
1673         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1674
1675 .PHONY: hs-check
1676 hs-check: hs-tests hs-shell
1677
1678 # E111: indentation is not a multiple of four
1679 # E121: continuation line indentation is not a multiple of four
1680 #       (since our indent level is not 4)
1681 # E125: continuation line does not distinguish itself from next logical line
1682 #       (since our indent level is not 4)
1683 # E127: continuation line over-indented for visual indent
1684 #       (since our indent level is not 4)
1685 # note: do NOT add E128 here; it's a valid style error in most cases!
1686 # I've seen real errors, but also some cases were we indent wrongly
1687 # due to line length; try to rework the cases where it is triggered,
1688 # instead of silencing it
1689 # E261: at least two spaces before inline comment
1690 # E501: line too long (80 characters)
1691 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1692
1693 # For excluding pep8 expects filenames only, not whole paths
1694 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1695
1696 LINT_TARGETS = pylint pylint-qa
1697 if HAS_PEP8
1698 LINT_TARGETS += pep8
1699 endif
1700 if HAS_HLINT
1701 LINT_TARGETS += hlint
1702 endif
1703
1704 .PHONY: lint
1705 lint: $(LINT_TARGETS)
1706
1707 .PHONY: pylint
1708 pylint: $(GENERATED_FILES)
1709         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1710         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1711
1712 .PHONY: pylint-qa
1713 pylint-qa: $(GENERATED_FILES)
1714         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1715         cd $(top_srcdir)/qa && \
1716           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1717           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1718
1719 .PHONY: pep8
1720 pep8: $(GENERATED_FILES)
1721         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1722         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1723           --repeat $(pep8_python_code)
1724
1725 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1726 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1727 .PHONY: hlint
1728 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1729         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1730         @rm -f doc/hs-lint.html
1731         if tty -s; then C="-c"; else C=""; fi; \
1732         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1733           --ignore "Use first" \
1734           --ignore "Use &&&" \
1735           --ignore "Use void" \
1736           --ignore "Reduce duplication" \
1737           --hint src/lint-hints \
1738           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1739         @if [ ! -f doc/hs-lint.html ]; then \
1740           echo "All good" > doc/hs-lint.html; \
1741         fi
1742
1743 # a dist hook rule for updating the vcs-version file; this is
1744 # hardcoded due to where it needs to build the file...
1745 dist-hook:
1746         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1747         rm -f $(top_distdir)/vcs-version
1748         cp -p $(srcdir)/vcs-version $(top_distdir)
1749
1750 # a distcheck hook rule for catching revision control directories
1751 distcheck-hook:
1752         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1753           echo "Found revision control files in final archive." 1>&2; \
1754           exit 1; \
1755         fi
1756         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1757           echo "Found Python byte code in final archive." 1>&2; \
1758           exit 1; \
1759         fi
1760         if find $(top_distdir) -name '*~' | grep .; then \
1761           echo "Found backup files in final archive." 1>&2; \
1762           exit 1; \
1763         fi
1764 # Empty files or directories should not be distributed. They can cause
1765 # unnecessary warnings for packagers. Directories used by automake during
1766 # distcheck must be excluded.
1767         if find $(top_distdir) -empty -and -not \( \
1768             -path $(top_distdir)/_build -or \
1769             -path $(top_distdir)/_inst \) | grep .; then \
1770           echo "Found empty files or directories in final archive." 1>&2; \
1771           exit 1; \
1772         fi
1773         if test -e $(top_distdir)/doc/man-html; then \
1774           echo "Found documentation including man pages in final archive" >&2; \
1775           exit 1; \
1776         fi
1777
1778 # Backwards compatible distcheck-release target
1779 distcheck-release: distcheck
1780
1781 distrebuildcheck: dist
1782         set -e; \
1783         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1784         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1785         cd $$builddir; \
1786         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1787         cd $(distdir); \
1788         ./configure; \
1789         $(MAKE) maintainer-clean; \
1790         cp $(abs_srcdir)/vcs-version .; \
1791         ./configure; \
1792         $(MAKE) $(AM_MAKEFLAGS)
1793
1794 dist-release: dist
1795         set -e; \
1796         for i in $(DIST_ARCHIVES); do \
1797           echo -n "Checking $$i ... "; \
1798           autotools/check-tar < $$i; \
1799           echo OK; \
1800         done
1801
1802 install-exec-local:
1803         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1804           "$(DESTDIR)${localstatedir}/log/ganeti" \
1805           "$(DESTDIR)${localstatedir}/run/ganeti"
1806
1807 .PHONY: apidoc
1808 if WANT_HSAPIDOC
1809 apidoc: py-apidoc hs-apidoc
1810 else
1811 apidoc: py-apidoc
1812 endif
1813
1814 .PHONY: py-apidoc
1815 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1816         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1817         $(RUN_IN_TEMPDIR) epydoc -v \
1818           --conf $(CURDIR)/epydoc.conf \
1819           --output $(CURDIR)/$(APIDOC_PY_DIR)
1820
1821 .PHONY: hs-apidoc
1822 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1823
1824 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1825         @test -n "$(HSCOLOUR)" || \
1826             { echo 'HsColour' not found during configure; exit 1; }
1827         @test -n "$(HADDOCK)" || \
1828             { echo 'haddock' not found during configure; exit 1; }
1829         rm -rf $(APIDOC_HS_DIR)/*
1830         for i in $(ALL_APIDOC_HS_DIRS); do \
1831           @mkdir_p@ $$i; \
1832           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1833         done
1834         set -e ; \
1835         export LC_ALL=en_US.UTF-8; \
1836         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1837         if [ "$(HS_NOCURL)" ]; \
1838         then OPTGHC="$$OPTGHC --optghc=$(HS_NOCURL)"; \
1839         fi; \
1840         if [ "$(HS_PARALLEL3)" ]; \
1841         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1842         fi; \
1843         if [ "$(HS_REGEX_PCRE)" ]; \
1844         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1845         fi; \
1846         for file in $(HS_LIBTESTBUILT_SRCS); do \
1847           f_nosrc=$${file##src/}; \
1848           f_notst=$${f_nosrc##test/hs/}; \
1849           f_html=$${f_notst%%.hs}.html; \
1850           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1851         done ; \
1852         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1853           -t ganeti -p src/haddock-prologue \
1854           --source-module="%{MODULE/.//}.html" \
1855           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1856           $$OPTGHC \
1857           $(HS_LIBTESTBUILT_SRCS)
1858
1859 .PHONY: TAGS
1860 TAGS: $(GENERATED_FILES)
1861         rm -f TAGS
1862         $(GHC) -e ":etags" -v0 \
1863           $(filter-out -O -Werror,$(HFLAGS)) \
1864           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1865           $(HS_LIBTEST_SRCS)
1866         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1867           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1868           -path './qa/*.py' | \
1869           etags -l python -a -
1870
1871 .PHONY: coverage
1872 if WANT_HTOOLS
1873 coverage: py-coverage hs-coverage
1874 else
1875 coverage: py-coverage
1876 endif
1877
1878 .PHONY: py-coverage
1879 py-coverage: $(GENERATED_FILES) $(python_tests)
1880         @test -n "$(PYCOVERAGE)" || \
1881             { echo 'python-coverage' not found during configure; exit 1; }
1882         set -e; \
1883         COVERAGE=$(PYCOVERAGE) \
1884         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1885         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1886         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1887         $(PLAIN_TESTS_ENVIRONMENT) \
1888         $(abs_top_srcdir)/autotools/gen-py-coverage \
1889         $(python_tests)
1890
1891 .PHONY: hs-coverage
1892 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1893         rm -f *.tix
1894         $(MAKE) $(AM_MAKEFLAGS) hs-check
1895         @mkdir_p@ $(COVERAGE_HS_DIR)
1896         hpc sum --union $(HPCEXCL) \
1897           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1898         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1899         hpc report coverage-hs.tix
1900         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1901
1902 # Special "kind-of-QA" target for htools, needs special setup (all
1903 # tools compiled with -fhpc)
1904 .PHONY: live-test
1905 live-test: all
1906         set -e ; \
1907         cd src; \
1908         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1909         rm -f *.tix *.mix; \
1910         ./live-test.sh; \
1911         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1912           --output=live-test.tix ; \
1913         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1914         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1915           --srcdir=.. $(HPCEXCL) ; \
1916         hpc report --srcdir=.. live-test $(HPCEXCL)
1917
1918 commit-check: distcheck lint apidoc
1919
1920 .PHONY: gitignore-check
1921 gitignore-check:
1922         @if [ -n "`git status --short`" ]; then \
1923           echo "Git status is not clean!" 1>&2 ; \
1924           git status --short; \
1925           exit 1; \
1926         fi
1927
1928 # target to rebuild all man pages (both groff and html output)
1929 .PHONY: man
1930 man: $(man_MANS) $(manhtml)
1931
1932 # Target that builds all binaries (including those that are not
1933 # rebuilt except when running the tests)
1934 .PHONY: really-all
1935 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1936
1937 # we don't need the ancient implicit rules:
1938 %: %,v
1939 %: RCS/%,v
1940 %: RCS/%
1941 %: s.%
1942 %: SCCS/s.%
1943
1944 -include ./Makefile.local
1945
1946 # vim: set noet :